#include "main.h"

//#define DEBUG
//#define DEBUG_NOISY

#ifdef DEBUG
#define WAIT 0
#else
#define WAIT 1
#endif

volatile int bSleep=0;

char RinPath[MAX_PATH];
char RomPath[MAX_PATH];
char RomName[MAX_PATH];
char SavePath[MAX_PATH];
SETTING setting;

// ----------------------------------------------------------------------------------------

// z[{^IɃR[obN
int exit_callback(void)
{
	bSleep=1;
	save_config();
	if (rom_get_loaded() && rom_has_battery())
		save_sram(get_sram(), rom_get_info()->ram_size);
	
	sceKernelExitGame();
	return 0;
}

// X[vsɃR[obN
void power_callback(int unknown, int pwrflags)
{
	// X[v܂ރp[XCb`OFFeۑ
	if(pwrflags & POWER_CB_POWER){
		bSleep=1;
		save_config();
		if (rom_get_loaded() && rom_has_battery())
			save_sram(get_sram(), rom_get_info()->ram_size);
	}
	// R[obN֐̍ēo^
	// ixĂ΂ꂽēo^ƂȂƎɃR[obNȂj
	int cbid = sceKernelCreateCallback("Power Callback", power_callback);
	PowerSetCallback(0, cbid);
}

// |[OpXbh
int CallbackThread(int args, void *argp)
{
	int cbid;
	
	// R[obN֐̓o^
	cbid = sceKernelCreateCallback("Exit Callback", exit_callback);
	SetExitCallback(cbid);
	cbid = sceKernelCreateCallback("Power Callback", power_callback);
	PowerSetCallback(0, cbid);
	
	// |[O
	KernelPollCallbacks();
}

int SetupCallbacks(void)
{
	int thid = 0;
	
	// |[OpXbh̐
	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
	if(thid >= 0)
		sceKernelStartThread(thid, 0, 0);
	
	return thid;
}

// ----------------------------------------------------------------------------------------

extern int skip, now_frame;
int xmain(int argc, char *argv)
{
	const unsigned int sync_time=16666;
	unsigned long prev_time, cur_time, next_time;
	unsigned long waitfc=0;
	int fd, romsize, ramsize, line, i, bDraw;
	char *p, savedir[MAX_PATH];
	
	pgMain(argc, argv);
	
	_strcpy(RinPath, argv);
	p = _strrchr(RinPath, '/');
	*++p = 0;
	
	SetupCallbacks();
	pgInit();
	pgScreenFrame(2,0);
	sceCtrlInit(0);
	wavoutInit();

	load_config();
	load_menu_bg();
	bgbright_change();
	if(setting.sound) wavout_enable=1;

	_strcpy(savedir,RinPath);
	_strcat(savedir,"SAVE");
	sceIoMkdir(savedir,0777);
	
	gb_init();
//	gb_set_skip(setting.frameskip);
	_strcpy(LastPath,RinPath);
	FilerMsg[0]=0;
	for(;;){
		while(!getFilePath(RomPath))
			;
		// w肵t@C[hB by ruka
		romsize = load_rom(RomPath);
		if (!romsize) continue;
		
		p = _strrchr(RomPath,'/');
		_strcpy(RomName, p+1);
		
		ramsize = load_sram();
		
		if(gb_load_rom(rom_image, romsize, sram_space, ramsize))
			break;
	}

	pgFillvram(0);
	pgScreenFlipV();
	pgFillvram(0);
	pgScreenFlipV();

#ifdef DEBUG
	unsigned long lasttick;
	unsigned long framecount;
	unsigned long lastclock;
	lasttick=paddata.frame;
#endif
	
	cur_time = sceKernelLibcClock();
	prev_time = cur_time;
	next_time = cur_time + sync_time;
	
	for(;;) {
		for(line=0; line<154; line++)
			gb_run();
		
		cur_time = sceKernelLibcClock();
#ifdef DEBUG
		framecount++;
		if (framecount>=60) {
			unsigned long l;

			//t[[g̎wWB60t[ł(usec)PUiŕ\B
			//tt[0x000f4240ƂȂA傫ƒxƂɂȂB𑜓x̂͊فB - LCK
			framecount=0;
#ifdef DEBUG_NOISY
			pgcLocate(50,0);
			pgcPuthex8(cur_time-lasttick);
			lasttick=cur_time;
			
			pgcLocate(50,2);
			pgcPuthex8(c_regs_PC);
			l=(cpu_read_direct(c_regs_PC)<<24)+(cpu_read_direct(c_regs_PC+1)<<16)+(cpu_read_direct(c_regs_PC+2)<<8)+(cpu_read_direct(c_regs_PC+3));
			pgcLocate(50,3);
			pgcPuthex8(l);

			unsigned long curclock=cpu_get_clock();
			pgcLocate(50,5);
			pgcPuthex8(cur_time-lastclock);
			lastclock=cur_time;

			pgcLocate(50,25);
			pgcPuthex8(g_regs.IF);
			pgcLocate(50,26);
			pgcPuthex8(g_regs.IE);
			extern byte c_regs_I;
			pgcLocate(50,27);
			pgcPuthex8(c_regs_I);
			
			// kmg
			pgcLocate(2, 2);
			pgcPuthex8(paddata.analog[CTRL_ANALOG_X]);
			pgcLocate(2, 3);
			pgcPuthex8(paddata.analog[CTRL_ANALOG_Y]);
#endif
		}
#endif
		if(Turbo){
			skip = 9;
			if (now_frame==0)
				pgScreenFlip();
		}else{
			if (cur_time > next_time){
				skip++;
				if(skip > setting.frameskip){
					skip=0;
					if(setting.vsync){
						pgWaitV();
						cur_time = sceKernelLibcClock();
					}
					prev_time = cur_time;
				}
			}else{
				if(setting.vsync){
					pgWaitV();
					cur_time = sceKernelLibcClock();
					prev_time = cur_time;
				}else if(WAIT){
					waitfc++;
					while(cur_time < prev_time+10000*(skip+1))
						cur_time = sceKernelLibcClock();
					if (!(waitfc&3)){
						while(cur_time < next_time)
							cur_time = sceKernelLibcClock();
					}
					prev_time = next_time;
				}else{
					prev_time = cur_time;
				}
				skip=0;
			}
			next_time = prev_time + sync_time * (skip+1);
			if (skip==0)
				pgScreenFlip();
		}
		
		// j[
		if(setting.key_config[6] && (paddata.buttons&setting.key_config[6])==setting.key_config[6]){
			wavout_enable=0;
			rin_menu();
			if(setting.sound) wavout_enable=1;
					
			cur_time = sceKernelLibcClock();
			prev_time = cur_time;
			next_time = cur_time + sync_time;
		}
		
		if(bSleep){
			wavout_enable=0;
			
			// sceDisplayWaitVblankStart()ĂŃX[ṽt[YB
			// ł邾EFCg肷B
			// pgWaitVn(120)ł̓X[vɃt[Y邱ƂB
			// pgWaitVn(180)łdOFFɉbKvB
			pgWaitVn(220);
			
			if(setting.sound) wavout_enable=1;
			
			cur_time = sceKernelLibcClock();
			prev_time = cur_time;
			next_time = cur_time + sync_time;
			
			bSleep=0;
		}
	}

	return 0;
}
